package amidagame;


import amidagame.packets.*;
import android.util.Log;

import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;

public class AmidaListenerC extends Listener {
	private AmidaClient client;
	
	public void connected(Connection arg0){
		// DO SOMETHING
		Log.i("Clinet","Connected with server!" + arg0.toString());
		PackageAmidaLogIn p = new PackageAmidaLogIn();
		
		// TODO Need minor change
		p.gameid = client.getGame().getGameid();
		client.client.sendTCP(new PackageAmidaLogIn());
	}
	
	public void disconnected(Connection arg0){
		// DO SOMETHING
		Log.i("Client","Disconnect from server");
	}
	
	public void received(Connection arg0, Object arg1){
		// DO SOMETHING
		//Log.i("Client", "Received something frmo the server");
		/*
		if (arg1 instanceof Packet0001LogInAccepted){
			boolean answer = ((Packet0001LogInAccepted) arg1).accepted;
			
			if (answer == true){
				client.sendTCP(new Packet0004Ack());
			} else {
				client.close();
			}
		}
		if (arg1 instanceof Packet0002Message){
			String message = ((Packet0002Message) arg1).message;
			Log.i("Client", "The message is: " + message);
		}
		if (arg1 instanceof Packet0004Ack){
			Log.i("Client", "Ack Received!");
			
			boolean connecting = ((Packet0004Ack) arg1).connecting;
			
			if (connecting){
				SThread st = new SThread();
				st.start();
			}
		}
		*/
		
		if (arg1 instanceof PackageAmidaLogInAccepted){
			Log.i("Client", "Log In was Accepted!");
			boolean answer = ((PackageAmidaLogInAccepted) arg1).answer;
			
			if (answer){
				client.getGame().setMyPid(((PackageAmidaLogInAccepted) arg1).pid);
				
				PackageAmidaAck p = new PackageAmidaAck();
				p.pid = ((PackageAmidaLogInAccepted) arg1).pid;
				p.connected = true;
				client.client.sendTCP(new PackageAmidaAck());
			} else {
				// Disconnect
			}
		}
		
		if (arg1 instanceof PackageAmidaAck){
			Log.i("Client", "Got an ACK!");
			UpdateThread ut = new UpdateThread();
			ut.start();
		}
		
		if (arg1 instanceof PackageNewLines){
			Log.i("Client", "New Lines Request!");
			
			PackageNewLines p = (PackageNewLines) arg1;
			for (int i = 0; i < p.x.length; i++){
				if (p.pid[i] != client.getGame().getMyPid()){
					client.getGame().addCross(p.x[i]*client.getGame().getCameraWidth(), p.y[i]*client.getGame().getCameraHeight());
					Log.i("Client", "Should've drawn something at " + p.x[i]*client.getGame().getCameraWidth() + " And "+p.y[i]*client.getGame().getCameraHeight());
				}
			}
			
			UpdateThread ut = new UpdateThread();
			ut.start();
		}
		
		if (arg1 instanceof PackageDrawLineReq){
			PackageDrawLineReq p = (PackageDrawLineReq) arg1;
			if (p.pid != client.getGame().getMyPid()){
				client.getGame().addCross(p.x*client.getGame().getCameraWidth(), p.y*client.getGame().getCameraHeight());
				Log.i("Client", "Should've drawn something at " + p.x*client.getGame().getCameraWidth() + " And "+p.y*client.getGame().getCameraHeight());
			}
		}
		
		if (arg1 instanceof PackageCoinInfo){
			PackageCoinInfo p = (PackageCoinInfo) arg1;
			for (int i = 0; i < p.lines.length; i++){
				client.getGame().addCoins(p.lines[i], p.yCords[i]*client.getGame().getCameraHeight(), 10);
			}
			client.getGame().drawBoxes(p.boxes);
			client.getGame().setCanDraw(true);
			client.getGame().getAt().setCounting(true);
		}
	}

	public void init(AmidaClient client) {
		this.client = client;
	}
	
	/*
	private void enterMessage(){
		Log.i("Client", "Say something!");
		
		while(true) {
			if (LCTClient.scanner.hasNext()){
				Packet0002Message mp = new Packet0002Message();
				mp.message = LCTClient.scanner.nextLine();
				if (mp.message.equals("Sync")){
					client.sendTCP(new Packet0003SyncReq());
					break;
				}
				client.sendTCP(mp);
				Log.i("Client", "Say something more!");
			}
		}
	}
	*/
	
	public class UpdateThread extends Thread{
		@Override
		public void run() {
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			
			// Send a Ack back to the server to make sure long time connection
			PackageAmidaAck p = new PackageAmidaAck();
			p.pid = client.getGame().getMyPid();
			p.gameid = client.getGame().getGameid();
			p.connected = true;
			client.client.sendTCP(p);
			
			Log.i("Client", "Ack sent!");
		}
		
	}
}
