package lanceGameRoomNetworking;

import java.util.Hashtable;

public class TrainWorld {
	private Hashtable<String, TrainRoom> world;
	
	public TrainWorld(){
		world = new Hashtable<String, TrainRoom>();
	}	
	
	public void makeTrainRoom(char[] trainId){
		makeTrainRoom(new String(trainId));
	}
	
	public void makeTrainRoom(String trainId){
		if (!world.containsKey(trainId)){
			world.put(trainId, new TrainRoom(trainId));
		}
	}
	
	public TrainRoom retrieveTrainRoom(char[] trainId){
		return retrieveTrainRoom(new String(trainId));
	}
	
	public TrainRoom retrieveTrainRoom(String trainId){
		if (world.containsKey(trainId)){
			return world.get(trainId);
		} else {
			makeTrainRoom(trainId);
			return world.get(trainId);
		}
	}
}
