package mainmenu;

import java.util.ArrayList;
import java.util.Arrays;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.traingame.LanceTrainRoomActivity;
import com.example.traingame.R;

public class ReadyActivity extends Activity {
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_ready);
		
		String gameName = getIntent().getExtras().getString("gameName");		
		TextView gameNameView = (TextView) findViewById(R.id.ready_game_name);
		gameNameView.setText(gameName);
		
		String[] usernames = getIntent().getExtras().getStringArray("usernames");
		ArrayList<String> unArray = new ArrayList<String>(Arrays.asList(usernames));
		
		ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, R.layout.list_users, unArray);			
		ListView listView = (ListView) findViewById(R.id.ready_listview);
		listView.setAdapter(adapter);	
	}
	
	public void ready(View view) {
		Intent intent = new Intent(this, MainMenuActivity.class);
	    intent.putExtra("ready", true);
	    setResult(1);
	    startActivity(intent);
	    finish();
	}
	
	public void notReady(View view) {
		Intent intent = new Intent(this, MainMenuActivity.class);
	    intent.putExtra("leaving", true);
	    setResult(1);
	    startActivity(intent);
	    finish();
	}
}
