package networking.component;

import networking.packets.*;

import com.esotericsoftware.kryonet.Client;
import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;

public class LCTListenerC extends Listener {
	private Client client;
	
	public void connected(Connection arg0){
		// DO SOMETHING
		System.out.println("AAAA-C");
		client.sendTCP(new Packet0000LogInfo());
	}
	
	public void disconnected(Connection arg0){
		// DO SOMETHING
		System.out.println("BBBB-C");
	}
	
	public void received(Connection arg0, Object arg1){
		// DO SOMETHING
		System.out.println("CCCC-C");
		if (arg1 instanceof Packet0001LogInAccepted){
			boolean answer = ((Packet0001LogInAccepted) arg1).accepted;
			
			if (answer == true){
				enterMessage();
			} else {
				client.close();
			}
		}
		if (arg1 instanceof Packet0002Message){
			String message = ((Packet0002Message) arg1).message;
			System.out.println("The message is: " + message);
			enterMessage();
			//client.close();
		}
	}

	public void init(Client client) {
		this.client = client;
	}
	
	private void enterMessage(){
		System.out.println("Say something!");
		
		while(true) {
			if (LCTClient.scanner.hasNext()){
				Packet0002Message mp = new Packet0002Message();
				mp.message = LCTClient.scanner.nextLine();
				if (mp.message.equals("Sync")){
					client.sendTCP(new Packet0003SyncReq());
					break;
				}
				client.sendTCP(mp);
				System.out.println("Say something more!");
			}
		}
	}
}
