package potatogame;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import android.annotation.SuppressLint;
import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;
@SuppressLint("UseSparseArrays")
public class potatoListenerS extends Listener {
	private potatoServer server;
	boolean connecting;
	private HashMap<Integer,List<Integer>> gameInfo = new HashMap<Integer,List<Integer>>();
	//this is used while the game is going so we can safely remove the old game Info key.
	//This is needed because a player can try to join with the same ID before on game ends, and 
	//writing over what's there can cause problems. We still need the info until a winner is determined though.
	private HashMap<Integer, HashMap<Integer, char[]>> userInfo = new HashMap<Integer, HashMap<Integer, char[]>>();
	//cons is connections when in the loading screen. cons2 is connections whil in game
	private HashMap<Integer, List<Connection>> Cons = new HashMap<Integer, List<Connection>>();
	private HashMap<Integer, List<Connection>> Cons2 = new HashMap<Integer, List<Connection>>();
	
	public potatoListenerS(potatoServer server){
		this.server = server;
		connecting = true;
	}
	
	public void connected(Connection arg0){
		// DO SOMETHING
		System.out.println("AAAA-S");
	}
	
	public void disconnected(Connection arg0){
		// DO SOMETHING
		System.out.println("BBBB-S");
	}
	
	public void received(Connection arg0, Object arg1){
		// DO SOMETHING
		//System.out.println("CCCC-S");
		if (arg1 instanceof Packet0000LogInfo){
			Packet0001LogInAccepted p = new Packet0001LogInAccepted();
			p.accepted = true;
			arg0.sendTCP(p);
		}
		if (arg1 instanceof Packet0002Message){
			String message = ((Packet0002Message) arg1).message;
			if (message.equals("wow wow")){
				System.out.println("VENUS");
			} else if (message.equals("Exit")){
				connecting = false;
			}
			System.out.println("The meEEEEEssage is: " + message);
		}
		if (arg1 instanceof PacketInt){
			int message = ((PacketInt) arg1).i;
			System.out.println("The meEEEEEssage is: " + message);
			String info = "" + message;
			if(info.startsWith("1")){
				//a game has ended and it's safe to remove info
				String g = info.substring(1);
				Integer gameID = Integer.parseInt(g);
				Cons2.remove(gameID);
			}
			if(info.startsWith("2")){
				//from game, gathering connections
				Integer t2 = new Integer(((PacketInt) arg1).gid);
				System.out.println("CONS2 CONNECTION ATTEMPT gameID is:" + t2);
				if(Cons2.containsKey(t2)){
					Cons2.get(t2).add(arg0);
				}
				else{
					Cons2.put(t2,new ArrayList<Connection>());
					Cons2.get(t2).add(arg0);
				}
			}
			if(info.startsWith("3")){
				//coming from in a game with the intent to pass to all
				Integer gameID = ((PacketInt)arg1).gid;
				System.out.println("CONS2 SENDING TO ALL ATTEMPT gameID is:" + gameID);
				if(Cons2.containsKey(gameID)){
					List<Connection> toSend = Cons2.get(gameID);
					for(int ind = 0; ind < toSend.size(); ind++){
						Connection con = toSend.get(ind);
						con.sendTCP(arg1);
					}
				}
				//server.sendAll(arg1);
			}
			else{
				arg0.sendTCP(arg1);
			}
		}
		if (arg1 instanceof Packet0003SyncReq){
			server.setCount(server.getCount() + 1);
			server.cList.add(arg0);
			if (server.getCount() >= 2){
				server.broadcastAgain();
			}
		}
		if (arg1 instanceof Packet0004Ack){
			//System.out.println("Ack received!");
			
			SThread st = new SThread(arg0);
			st.start();
		}
		if(arg1 instanceof PacketGStart){
			//coming from a loading screen with the intent to pass to all
			if(((PacketGStart)arg1).i == 100){
				Integer gameID = Integer.valueOf(((PacketGStart)arg1).i2);
				Integer uID =  Integer.valueOf(((PacketGStart)arg1).i3);
				Integer waiting = Integer.valueOf(((PacketGStart)arg1).i4);
				char[] uName = ((PacketGStart)arg1).i5;
				int connected = 1;
				//Boolean already = false;
				if(!gameInfo.containsKey(gameID)){
					List<Integer> player = new ArrayList<Integer>();
					player.add(waiting);
					player.add(Integer.valueOf(1));
					gameInfo.put(gameID,player);
					userInfo.put(gameID, new HashMap<Integer, char[]>());
					userInfo.get(gameID).put(uID,uName);
					Cons.put(gameID,new ArrayList<Connection>());
					Cons.get(gameID).add(arg0);
					tellSelf(arg0,connected);
					
				}
				else{
					//if(!(userInfo.get(gameID).containsKey(uID))){
						userInfo.get(gameID).put(uID,uName);
						Cons.get(gameID).add(arg0);
						connected = gameInfo.get(gameID).get(1);
						connected++;
						tellSelf(arg0,connected);
						if(connected < waiting){
							gameInfo.get(gameID).set(1, connected);
						}
						else{
							List<Connection> toSend = Cons.get(gameID);
							Cons.remove(gameID);
							if(!Cons2.containsKey(gameID)){
								System.out.println("CONS2 TESTED WHEN LEAVING LOADING gameID is:" + gameID);
								Cons2.put(gameID,new ArrayList<Connection>());
							}
							PacketInt startC = new PacketInt();
							startC.i = 100;
							PacketHash hPack = new PacketHash();
							hPack.h = userInfo.get(gameID);
							gameInfo.remove(gameID);
							userInfo.remove(gameID);
							for(int ind = 0; ind < toSend.size(); ind++){
								Connection con = toSend.get(ind);
								con.sendTCP(startC);
								con.sendTCP(hPack);
							}
								
						}
					//}
					//else{
					//	already = true;
					//}
				}
			}
		}
	}
	
	public void tellSelf(Connection arg0, int connected){
		//tell itself that this is the one it sent
		//if(!already){
			PacketInt yourC = new PacketInt();
			int tCon = connected;
			String temp = "2" + tCon;
			Integer temp2 = Integer.parseInt(temp);
			yourC.i = temp2.intValue();
			arg0.sendTCP(yourC);
		//}
	}
	
	public class SThread extends Thread{
		Connection con;
		
		public SThread(Connection con){
			this.con = con;
		}	
		
		@Override
		public void run() {
			// TODO Auto-generated method stub
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			Packet0004Ack p = new Packet0004Ack();
			p.connecting = connecting;
			con.sendTCP(p);
			//System.out.println("Ack sent");
		}
		
	}
}
