package potatogame;

import java.util.Random;

import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;

import android.util.Log;

import com.example.traingame.SceneManager;

public class timerHandler {
	private passHandler PH;
	private SceneManager SM;
	private potatoSetup PS;
	private Random r;
	private int startPlay;
	String gameID = "0";
	// unless the player swipes, switching this to winning, then
	// they will loose when 3 seconds are up after they recieve the potato
	public boolean loosing = false;
	//oops, sorry about the similar naming. do not confuse this with the
	//class you are in. This is andEngine's timer handler
	private TimerHandler TM;
	private TimerHandler animate;
	private TimerHandler cDown;
	
	private Boolean lost = false;
	
	public timerHandler(passHandler pHan, SceneManager sMan, potatoSetup ps, Integer gi){
		PH = pHan;
		SM = sMan;
		PS = ps;
		gameID = "" + gi.intValue();
		startPlay = PH.getNum();
		//between 25 and 45 seconds
		r = new Random();
		float time = (r.nextFloat() * 20 )+ 25;
		float test = 30;
		TM = new TimerHandler(test,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				PH.timeUp();
				SM.engine.unregisterUpdateHandler(pTimerHandler);
				if(!lost){
				if(PH.getCur() == startPlay){
					PS.randomUser();
					PS.markForSet();
					PH.animateEx();
					TimerHandler continuing = new TimerHandler(3f,new ITimerCallback(){
					public void onTimePassed(TimerHandler pTimerHandler){
							SM.engine.clearUpdateHandlers();
							lost = true;
							loosing = false;
							SM.setCurrentS(SceneManager.AllScenes.LOSSPOTATO);
						}
					});
					SM.engine.registerUpdateHandler(continuing);
				}
				else{
					int check = PS.getP();
					if(check == 1){
						PS.randomUser();
						PS.markForSet();
						PH.animateEx();
						TimerHandler continuing = new TimerHandler(3f,new ITimerCallback(){
						public void onTimePassed(TimerHandler pTimerHandler){
								SM.engine.clearUpdateHandlers();
								lost = true;
								PacketInt p = new PacketInt();
								String te = "1" + gameID;
								Integer te2 = Integer.parseInt(te);
								p.i = te2.intValue();
								PH.sendWin(p);
								SM.setCurrentS(SceneManager.AllScenes.WINPOTATO);
							}
						});
						SM.engine.registerUpdateHandler(continuing);
					}
					else{
						PH.animateEx();
						TimerHandler continuing = new TimerHandler(3f,new ITimerCallback(){
						public void onTimePassed(TimerHandler pTimerHandler){
								PS.remSprite(PH.getCur() + 1);
								SM.setPotatoPlayers(PS.getP() - 1, PH.getLow(),PS.getUnum());
								SM.engine.clearUpdateHandlers();
								lost = true;
								SM.setCurrentS(SceneManager.AllScenes.NEXTPOTATO);
							}
						});
						SM.engine.registerUpdateHandler(continuing);
					}
				}
				}
			}
			});
		animate = new TimerHandler(test - 5,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				SM.engine.unregisterUpdateHandler(pTimerHandler);
				PH.animatePo();
			}
			});
		SM.engine.registerUpdateHandler(TM);
		SM.engine.registerUpdateHandler(animate);
		animate.reset();
	}
	
	public void countDown(){
		loosing = true;
		cDown = new TimerHandler(4f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				if(loosing && PH.getCur() == startPlay && !lost){
					//if you do not unregister TM than a loose screen
					//will randomly pop up while you are in another menu
					//once the original timer is up
					
					SM.engine.unregisterUpdateHandler(TM);
					SM.engine.unregisterUpdateHandler(pTimerHandler);
					if(animate != null)
						animate.reset();
					PS.randomUser();
					PS.markForSet();
					
					PH.sendCDLoss();
					//remember to make something do this: PS.remSprite(PH.getCur() + 1);
					//on ever other machine, then go to next potato.
					lost = true;
					//if I don't set this back it causes problems when you
					//start a new game
					loosing = false;
					SM.setCurrentS(SceneManager.AllScenes.LOSSPOTATO);
				}
				else{
					SM.engine.unregisterUpdateHandler(pTimerHandler);
				}
				
			}
		});
		SM.engine.registerUpdateHandler(cDown);
	}
	
	public void passed(){
		loosing = false;
		SM.engine.unregisterUpdateHandler(cDown);
	}
	
	public void recieveLoss(int i){
		Log.i("timer rec", "KITTEN5 i = " + i + " startP = " + startPlay);
		//this is a premature loss from someone not passing on time
		if(animate != null)
			animate.reset();
		if(i != startPlay && !lost){
			lost = true;
			int check = PS.getP();
			if(check == 1){
				PS.randomUser();
				PS.markForSet();
				SM.engine.clearUpdateHandlers();
				PacketInt p = new PacketInt();
				String te = "1" + gameID;
				Integer te2 = Integer.parseInt(te);
				p.i = te2.intValue();
				PH.sendWin(p);
				SM.setCurrentS(SceneManager.AllScenes.WINPOTATO);
			}
			else{
				PS.remSprite(i + 1);
				SM.setPotatoPlayers(PS.getP() - 1, PH.getLow(),PS.getUnum());
				SM.engine.clearUpdateHandlers();
				SM.setCurrentS(SceneManager.AllScenes.NEXTPOTATO);
			}
		}
	}
}
