package viewUsers;

import java.util.ArrayList;
import java.util.HashMap;

import mainmenu.MainMenuActivity;
import mainmenu.networking.GameJoinClient;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.traingame.R;

public class ViewSingleUserActivity extends Activity {	

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_view_single_user);		
		
		if (getIntent().getExtras() != null) {		
			//username
			String username = getIntent().getExtras().getString("username");		
			TextView usernameView = (TextView) findViewById(R.id.view_user_username);
			usernameView.setText(username);
			//userscore
			String userscore = getIntent().getExtras().getString("userscore");		
			TextView userscoreView = (TextView) findViewById(R.id.view_user_userscore);
			userscoreView.setText("Userscore: " + userscore);
			//plays
			String plays = getIntent().getExtras().getString("plays");		
			TextView playsView = (TextView) findViewById(R.id.view_user_played_with);
			playsView.setText("Num Times Played With: " + plays);
			//trainscore
			String current_train_score = getIntent().getExtras().getString("train");		
			TextView current_train_scoreView = (TextView) findViewById(R.id.view_user_train_score);
			current_train_scoreView.setText("Current My Train Score: " + current_train_score);
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	public void back(View view) {
		finish();
	}
	
	@Override
	public void onStop(){
		super.onStop();
		finish();
	}
}
