package wizardgame;

import java.util.Random;

import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;
import org.andengine.entity.primitive.Line;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.sprite.AnimatedSprite;
import org.andengine.entity.sprite.Sprite;
import org.andengine.entity.text.Text;
import org.andengine.util.color.Color;

import android.util.Log;

import com.example.traingame.SceneManager;

public class spellHandler {
	private Boolean s1 = false;
	private Boolean s2 = false;
	private Boolean s3 = false;
	private Boolean s4 = false;
	private Boolean s5 = false;
	private Boolean s6 = false;
	
	private Line l1;
	private Line l2;
	private Line l3;
	
	private int pressed;
	
	private Scene ws;
	private SceneManager sm;
	private Sprite stars[][] = new Sprite[6][2];
	private Sprite elements[] = new Sprite[4];
	//text strings in the order chances, rounds, timer
	private Text info[] = new Text[5];
	private AnimatedSprite[] Magic = new AnimatedSprite[4];
	
	private int round = 0;
	private int chances = 2;
	private int chances2 = 2;
	private int time = 0;
	
	//half of a star's width or height.
	private float r;
	
	private TimerHandler countDown;
	private TimerHandler castTime;
	
	private Random ran = new Random();
	
	private int toCast = 1;
	private int casted = 0;
	private int countered = 0;
	
	private int toSend = 1;
	private int sent = 0;
	
	private wizardClient wc;
	
	//only relevent to multiplayer.
	//used to tell if the cast time countdown has been registered yet
	private Boolean ctRegistered = false;
	
	private Boolean clickable = false;
		
	//spells: fire = 0 water = 1 earth = 2 wind = 3
	private int spellsCasted[] = new int[100];
	
	private Boolean pTurn = false;
	private Boolean twoPlay = false;
	
	private Boolean opCasting = false;
	private Boolean pleaseResp = false;
	
	
	private Integer gameID = 0;
	
	private Boolean win = false;
	
	private void reset(){
		 s1 = false;
		 s2 = false;
		 s3 = false;
		 s4 = false;
		 s5 = false;
		 s6 = false;
		 
		round = 0;
		chances = 2;
		chances2 =2;
		time = 0;
		updateRound();
		updateChances();
		updateTimer();
		toCast = 1;
		casted = 0;
		countered = 0;
		
		toSend = 1;
		sent = 0;
		clickable = false;
		ctRegistered = false;
		spellsCasted = new int[100];
		resetStars();
		
		opCasting = false;
		pleaseResp = false;
		win = false;
	}
	
	public spellHandler(Scene WS, Sprite st[][], Sprite el[], Text t[], SceneManager SM, boolean tp, boolean pt, Integer gid, AnimatedSprite[] mag){
		gameID = gid;
		ws = WS;
		wc = new wizardClient(this);
		PacketInt p = new PacketInt();
		String temp = "2" + gameID;
		Integer temp2 = Integer.decode(temp);
		p.i = temp2.intValue();
		wc.wclient.sendTCP(p);
		
		stars = st;
		Magic = mag;
		sm = SM;
		
		twoPlay = tp;
		pTurn = pt;
		r = stars[0][0].getWidth()/2;
		elements = el;
		info = t;
		//just to be safe
				reset();
		countDown = new TimerHandler(1f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				if(time > 0){
					time --;
					updateTimer();
					pTimerHandler.reset();
				}
				else{
					if(clickable){
						clickable = false;
						miss();
					}
				}
			}
		});
		
		ws.registerUpdateHandler(countDown);
		if(!twoPlay){
			castTime = new TimerHandler(1f,new ITimerCallback(){
				public void onTimePassed(TimerHandler pTimerHandler){
					for(int i = 0; i < 4; i++){
						ws.detachChild(elements[i]);
					}
					casted++;
					if(casted < toCast){
						opCasting = true;
						pleaseResp = false;
						updateInstruct();
						clickable = false;
						ws.registerUpdateHandler(new TimerHandler(.5f,new ITimerCallback(){
							public void onTimePassed(TimerHandler pTimerHandler){
								ws.unregisterUpdateHandler(pTimerHandler);
								cast();
							}
						}));
					}
					else{
						opCasting = false;
						pleaseResp = true;
						updateInstruct();
						clickable = true;
						time = 31;
						countDown.reset();
					}
				}
			});
			cast();
			ws.registerUpdateHandler(new TimerHandler(3f,new ITimerCallback(){
				public void onTimePassed(TimerHandler pTimerHandler){
					castTime.reset();
					ws.registerUpdateHandler(castTime);
				}
			}));
		}
		else{
			castTime = new TimerHandler(1f,new ITimerCallback(){
				public void onTimePassed(TimerHandler pTimerHandler){
					for(int i = 0; i < 4; i++){
						ws.detachChild(elements[i]);
					}
					casted++;
					if(casted < toCast){
						clickable = false;
					}
					else{
						clickable = true;
						time = 31;
						countDown.reset();
					}
				}
			});
			if(pTurn){
				clickable = true;
				time = 31;
				countDown.reset();
			}
		}
		
	}
	
	public void press(int i){
		if(pressed < 4 && clickable){
			if(i == 1){
				s1 = !s1;
				if(s1){
					ws.attachChild(stars[0][1]);
					ws.detachChild(stars[0][0]);
					ws.registerTouchArea(stars[0][1]);
					pressed++;
				}
				else{
					ws.attachChild(stars[0][0]);
					ws.detachChild(stars[0][1]);
					ws.registerTouchArea(stars[0][0]);
					pressed--;
				}
			}
			if(i == 2){
				s2 = !s2;
				if(s2){
					ws.attachChild(stars[1][1]);
					ws.detachChild(stars[1][0]);
					ws.registerTouchArea(stars[1][1]);
					pressed++;
				}
				else{
					ws.attachChild(stars[1][0]);
					ws.detachChild(stars[1][1]);
					ws.registerTouchArea(stars[1][0]);
					pressed--;
				}
			}
			if(i == 3){
				s3 = !s3;
				if(s3){
					ws.attachChild(stars[2][1]);
					ws.detachChild(stars[2][0]);
					ws.registerTouchArea(stars[2][1]);
					pressed++;
				}
				else{
					ws.attachChild(stars[2][0]);
					ws.detachChild(stars[2][1]);
					ws.registerTouchArea(stars[2][0]);
					pressed--;
				}
			}
			if(i == 4){
				s4 = !s4;
				if(s4){
					ws.attachChild(stars[3][1]);
					ws.detachChild(stars[3][0]);
					ws.registerTouchArea(stars[3][1]);
					pressed++;
				}
				else{
					ws.attachChild(stars[3][0]);
					ws.detachChild(stars[3][1]);
					ws.registerTouchArea(stars[3][0]);
					pressed--;
				}
			}
			if(i == 5){
				s5 = !s5;
				if(s5){
					ws.attachChild(stars[4][1]);
					ws.detachChild(stars[4][0]);
					ws.registerTouchArea(stars[4][1]);
					pressed++;
				}
				else{
					ws.attachChild(stars[4][0]);
					ws.detachChild(stars[4][1]);
					ws.registerTouchArea(stars[4][0]);
					pressed--;
				}
			}
			if(i == 6){
				s6 = !s6;
				if(s6){
					ws.attachChild(stars[5][1]);
					ws.detachChild(stars[5][0]);
					ws.registerTouchArea(stars[5][1]);
					pressed++;
				}
				else{
					ws.attachChild(stars[5][0]);
					ws.detachChild(stars[5][1]);
					ws.registerTouchArea(stars[5][0]);
					pressed--;
				}
			}
			
			if(pressed == 4){
				checkSpell();
			}
		}
	}
	
	public void checkSpell(){		
		//in the casted spells: fire = 0 water = 1 earth = 2 wind = 3
		
		if(s2 && s3 && s4 && s6){
			//water
			l1 = new Line(stars[1][0].getX() +r,stars[1][0].getY() +r,stars[2][0].getX() +r,stars[2][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l2 = new Line(stars[5][0].getX() +r,stars[5][0].getY() +r,stars[2][0].getX() +r,stars[2][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l3 = new Line(stars[3][0].getX() +r,stars[3][0].getY() +r,stars[5][0].getX() +r,stars[5][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l1.setColor(new Color(1,1,0));
			l1.setLineWidth(5f);
			l2.setColor(new Color(1,1,0));
			l2.setLineWidth(5f);
			l3.setColor(new Color(1,1,0));
			l3.setLineWidth(5f);
			ws.attachChild(l1);
			ws.attachChild(l2);
			ws.attachChild(l3);
			AnimatedSprite magic = Magic[0];
			magic.setPosition(sm.camera.getWidth()/2 - 150, sm.camera.getHeight()*0.7f - 150);
			magic.setScale(0.5f);
			magic.animate(100);
			ws.attachChild(magic);
			if(!twoPlay || !pTurn){
				if(spellsCasted[countered] == 0){
					block();
				}
				else{
					miss();
				}
			}
			else{
				send(1);
			}
		}
		else if(s1 && s3 && s4 && s6){
			//fire
			l1 = new Line(stars[0][0].getX() +r,stars[0][0].getY() +r,stars[3][0].getX() +r,stars[3][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l2 = new Line(stars[5][0].getX() +r,stars[5][0].getY() +r,stars[3][0].getX() +r,stars[3][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l3 = new Line(stars[5][0].getX() +r,stars[5][0].getY() +r,stars[2][0].getX() +r,stars[2][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l1.setColor(new Color(1,1,0));
			l1.setLineWidth(5f);
			l2.setColor(new Color(1,1,0));
			l2.setLineWidth(5f);
			l3.setColor(new Color(1,1,0));
			l3.setLineWidth(5f);
			ws.attachChild(l1);
			ws.attachChild(l2);
			ws.attachChild(l3);
			AnimatedSprite magic = Magic[1];
			magic.setPosition(sm.camera.getWidth()/2 - 150, sm.camera.getHeight()*0.7f - 150);
			magic.setScale(0.5f);
			magic.animate(100);
			ws.attachChild(magic);
			if(!twoPlay || !pTurn){
				if(spellsCasted[countered] == 2){
					block();
				}
				else{
					miss();
				}
			}
			else{
				send(0);
			}
		}
		else if(s1 && s2 && s5 && s6){
			//wind
			l1 = new Line(stars[1][0].getX() +r,stars[1][0].getY() +r,stars[0][0].getX() +r,stars[0][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l2 = new Line(stars[1][0].getX() +r,stars[1][0].getY() +r,stars[4][0].getX() +r,stars[4][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l3 = new Line(stars[4][0].getX() +r,stars[4][0].getY() +r,stars[5][0].getX() +r,stars[5][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l1.setColor(new Color(1,1,0));
			l1.setLineWidth(5f);
			l2.setColor(new Color(1,1,0));
			l2.setLineWidth(5f);
			l3.setColor(new Color(1,1,0));
			l3.setLineWidth(5f);
			ws.attachChild(l1);
			ws.attachChild(l2);
			ws.attachChild(l3);
			AnimatedSprite magic = Magic[2];
			magic.setPosition(sm.camera.getWidth()/2 - 150, sm.camera.getHeight()*0.7f - 150);
			magic.setScale(0.5f);
			magic.animate(100);
			ws.attachChild(magic);
			if(!twoPlay || !pTurn){
				if(spellsCasted[countered] == 1){
					block();
				}
				else{
					miss();
				}
			}
			else{
				send(3);
			}
		}
		else if(s1 && s2 && s3 && s5){
			//earth
			l1 = new Line(stars[1][0].getX() +r,stars[1][0].getY() +r,stars[4][0].getX() +r,stars[4][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l2 = new Line(stars[0][0].getX() +r,stars[0][0].getY() +r,stars[4][0].getX() +r,stars[4][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l3 = new Line(stars[2][0].getX() +r,stars[2][0].getY() +r,stars[4][0].getX() +r,stars[4][0].getY() +r,sm.activity.getVertexBufferObjectManager());
			l1.setColor(new Color(1,1,0));
			l1.setLineWidth(5f);
			l2.setColor(new Color(1,1,0));
			l2.setLineWidth(5f);
			l3.setColor(new Color(1,1,0));
			l3.setLineWidth(5f);
			ws.attachChild(l1);
			ws.attachChild(l2);
			ws.attachChild(l3);
			AnimatedSprite magic = Magic[3];
			magic.setPosition(sm.camera.getWidth()/2 - 150, sm.camera.getHeight()*0.7f - 150);
			magic.setScale(0.5f);
			magic.animate(100);
			ws.attachChild(magic);
			if(!twoPlay || !pTurn){
				if(spellsCasted[countered] == 3){
					block();
				}
				else{
					miss();
				}
			}
			else{
				send(2);
			}
		}
		else{
			miss();
		}
		TimerHandler tm = new TimerHandler(1.5f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				ws.unregisterUpdateHandler(pTimerHandler);
				//for layering purposes
				resetStars();
				pressed = 0;
				ws.detachChild(l1);
				ws.detachChild(l2);
				ws.detachChild(l3);
				for(int i =0; i < 4; i++){
					ws.detachChild(Magic[i]);
				}
			}
		});
		
		ws.registerUpdateHandler(tm);
	}
	
	private void disatachStars(){
		ws.detachChild(stars[0][0]);
		ws.detachChild(stars[0][1]);
		ws.detachChild(stars[1][0]);
		ws.detachChild(stars[1][1]);
		ws.detachChild(stars[2][0]);
		ws.detachChild(stars[2][1]);
		ws.detachChild(stars[3][0]);
		ws.detachChild(stars[3][1]);
		ws.detachChild(stars[4][0]);
		ws.detachChild(stars[4][1]);
		ws.detachChild(stars[5][0]);
		ws.detachChild(stars[5][1]);
	}
	
	private void resetStars(){
		disatachStars();
		ws.attachChild(stars[0][0]);
		ws.attachChild(stars[1][0]);
		ws.attachChild(stars[2][0]);
		ws.attachChild(stars[3][0]);
		ws.attachChild(stars[4][0]);
		ws.attachChild(stars[5][0]);
		s1 = false;
		s2 = false;
		s3 = false;
		s4 = false;
		s5 = false;
		s6 = false;
	}
	
	private void updateRound(){
		info[1].setText("Rounds: " + round);
	}
	
	private void updateChances(){
		if(twoPlay){
			info[0].setText("YOUR\nChances: " + chances);
			info[3].setText("OPPONENT'S\nChances: " + chances2);
		}
		else{
			info[0].setText("Chances: " + chances);
		}
	}
	
	private void updateTimer(){
		info[2].setText("Timer:\n" + time);
	}
	
	private void updateInstruct(){
		if(twoPlay){
			if(pTurn){
				if(toSend == 1){
					info[4].setText("Your turn: please cast 1 spell!");
				}
				else{
					info[4].setText("Your turn: please cast " + toSend + " spells!");
				}
			}
			else if(pleaseResp){
				info[4].setText("Opponent's spells casted, please block!");
			}
			else if(opCasting){
				if(toCast == 1){
					info[4].setText("Opponent's turn: they will cast 1 spell!");
				}
				else{
					info[4].setText("Opponent's turn: they will cast " + toCast + " spells!");
				}	
			}
			else{
				info[4].setText("Your opponent is responding to your casts");
			}
		}
	}
	
	private void cast(){
		int spell = ran.nextInt(4);
		spellsCasted[casted] = spell;
		ws.attachChild(elements[spell]);
		castTime.reset();
	}
	
	public void recCast(int i){
		if(!pTurn){
			//NOTE THIS WILL GO RIGHT AWAY WHEN NEW ONES ARE SENT: FIX 
			if(i < 4 && i >= 0 && casted < toCast){
				if(casted == toCast - 1){
					opCasting = false;
					pleaseResp = true;
				}
				else{
					//opCasting = true;
					pleaseResp = false;
				}
				updateInstruct();
				spellsCasted[casted] = i;
				//double check that it's not attached first or it will crash.
				ws.attachChild(elements[i]);
				clickable = false;
				if(!ctRegistered){
					ws.registerUpdateHandler(castTime);
				}
				castTime.reset();
			}
		}
	}
	
	private void miss(){
		if(twoPlay){
			opCasting = true;
			pleaseResp = false;
			if(pTurn){
				sendMiss(true);
			}
			else{
				sendMiss(false);
			}
		}
		casted = 0;
		countered = 0;
		if(!twoPlay){
			clickable = false;
			time = 0;
		}
		else{
			if(!pTurn){
				pTurn = true;
				clickable = true;
				time = 31;
				countDown.reset();
			}
			else{
				pTurn = false;
				clickable = false;
				time = 0;
			}
			updateInstruct();
		}
		updateTimer();
		chances --;
		updateChances();
		if(chances > 0){
			round++;
			updateRound();
			if(round % 6 == 0 && round != 0 && toCast < 100){
				//if(!twoPlay)
					toCast++;
				if(twoPlay){
					toSend++;
					updateInstruct();
				}
			
			}
			if(!twoPlay){
				ws.registerUpdateHandler(new TimerHandler(2f,new ITimerCallback(){
					public void onTimePassed(TimerHandler pTimerHandler){
						ws.unregisterUpdateHandler(pTimerHandler);
						cast();
					}
				}));
			}
		}
		else{
			ws.unregisterUpdateHandler(castTime);
			ws.unregisterUpdateHandler(countDown);
			ws.detachChild(elements[0]);
			ws.detachChild(elements[1]);
			ws.detachChild(elements[2]);
			ws.detachChild(elements[3]);
			PacketInt loss = new PacketInt();
			loss.i = 5;
			loss.gid = gameID;
			sm.setCurrentS(SceneManager.AllScenes.LOSSWIZARD);
		}
	}
	
	private void block(){
		countered++;
		if(countered == toCast){
			pleaseResp = false;
			updateInstruct();
			countered = 0;
			casted = 0;
			round++;
			updateRound();
			if(round % 6 == 0 && round != 0 && toCast < 100){
				//if(!twoPlay)
					toCast++;
				if(twoPlay)
					toSend++;
			}
			if(!twoPlay){
				clickable = false;
				time = 0;
				updateTimer();
				ws.registerUpdateHandler(new TimerHandler(2f,new ITimerCallback(){
					public void onTimePassed(TimerHandler pTimerHandler){
						ws.unregisterUpdateHandler(pTimerHandler);
						cast();
					}
				}));
			}
			else{
				pTurn = true;
				clickable = true;
				time = 31;
				updateTimer();
				updateInstruct();
				countDown.reset();
			}
		}
	}
	
	private void send(int i){
		sent++;
		PacketInt pi = new PacketInt();
		String temp = "3" + toSend + i;
		Integer temp2 = Integer.parseInt(temp);
		pi.i = temp2.intValue();
		pi.gid = gameID;
		wc.wclient.sendTCP(pi);
		if(sent >= toSend){
			opCasting = false;
			pleaseResp = false;
			sent = 0;
			time = 0;
			clickable = false;
			updateTimer();
			pTurn = false;
			updateInstruct();
		}
	}
	
	private void sendMiss(boolean i){
		PacketInt pi = new PacketInt();
		if(i)
			pi.i = 40;
		else
			pi.i = 41;
		pi.gid = gameID;
		wc.wclient.sendTCP(pi);
	}
	
	public void recMiss(boolean i){
		if(twoPlay){
			opCasting = false;
			pleaseResp = false;
			casted = 0;
			if(!i){
				pTurn = false;
				clickable = false;
				time = 0;
			}
			else{
				round++;
				updateRound();
				if(round % 6 == 0 && round != 0 && toSend < 100){
					toSend++;
				}
				pTurn = true;
				clickable = true;
				time = 31;
				countDown.reset();
			}
			updateInstruct();
			updateTimer();
			chances2 --;
			updateChances();
				if(chances2 <= 0){
					ws.unregisterUpdateHandler(castTime);
					ws.unregisterUpdateHandler(countDown);
					ws.detachChild(elements[0]);
					ws.detachChild(elements[1]);
					ws.detachChild(elements[2]);
					ws.detachChild(elements[3]);
					PacketInt loss = new PacketInt();
					loss.i = 5;
					loss.gid = gameID;
					win = true;
					sm.setCurrentS(SceneManager.AllScenes.LOSSWIZARD);
				}
			}
	}
	
	public void setCast(int i){
		if(toCast != i)
			toCast = i;
	}
	
	public int getRound(){
		return round;
	}
	
	public Boolean getWin(){
		return win;
	}
}
