package wizardgame;

import loadingscenes.LWizardSetup;

import android.util.Log;

import com.esotericsoftware.kryonet.Client;
import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;

public class wizardListener extends Listener {
	private Client wclient;
	private LWizardSetup lws = null;
	private spellHandler ws = null;
	
	public void setLWS(LWizardSetup LWS){
		lws = LWS;
	}
	
	public void setWS(spellHandler WS){
		ws = WS;
	}
	
	public void connected(Connection arg0){
		// DO SOMETHING
		Log.i("Clinet","Connected with server!" + arg0.toString());
		//wclient.sendTCP(new Packet0000LogInfo());c
	}
	
	public void disconnected(Connection arg0){
		// DO SOMETHING
		Log.i("Client","Disconnect from server");
	}
	
	public void received(Connection arg0, Object arg1){
		// DO SOMETHING
		//Log.i("Client", "Received something from the server");
		if (arg1 instanceof Packet0001LogInAccepted){
			boolean answer = ((Packet0001LogInAccepted) arg1).accepted;
			
			// TODO Something to be finished
			
			if (answer == true){
				wclient.sendTCP(new Packet0004Ack());
			} else {
				wclient.close();
			}
		}
		if (arg1 instanceof Packet0002Message){
			String message = ((Packet0002Message) arg1).message;
			Log.i("Client", "The message is: " + message);
		}
		if (arg1 instanceof PacketInt){
			int message = ((PacketInt) arg1).i;
			String info = "" + message;
			if(info.startsWith("1")){
				if(lws != null){
					Integer temp = Integer.parseInt(info.substring(1,2));
					lws.addConnect(temp.intValue());
				}
			}
			else if(info.startsWith("2")){
				if(lws != null && info.length() >= 2){
					Integer t = Integer.parseInt(info.substring(1,2));
					if(t.intValue() == 1){
						lws.setTurn(true);
					}
					else if(t.intValue() == 2){
						lws.setTurn(false);
					}
				}
			}
			else if(info.startsWith("3")){
				if(ws != null && info.length() >= 3){
					Integer t =  Integer.parseInt(info.substring(1,2));
					ws.setCast(t.intValue());
					t = Integer.parseInt(info.substring(2,3));
					ws.recCast(t.intValue());
				}
			}
			else if(info.startsWith("4")){
				if(ws != null){
					if(message == 40){
						ws.recMiss(true);
					}
					else if(message == 41){
						ws.recMiss(false);
					}
				}
			}
		}
		if (arg1 instanceof Packet0004Ack){
			//Log.i("Client", "Ack Received!");
			
			boolean connecting = ((Packet0004Ack) arg1).connecting;
			
			if (connecting){
				SThread st = new SThread();
				st.start();
			}
		}
	}

	public void init(Client client) {
		this.wclient =  client;
	}
	
	
	public class SThread extends Thread{
		@Override
		public void run() {
			// TODO Auto-generated method stub
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			wclient.sendTCP(new Packet0004Ack());
			//Log.i("Client", "Ack sent!");
		}
		
	}
}
