package wizardgame;

import java.io.IOException;
import java.util.LinkedList;


import com.esotericsoftware.kryo.Kryo;
import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Server;

public class wizardServer {
	private Server server;
	public LinkedList<Connection> cList;
	public LinkedList<Connection> cList2;
	private int count;
	
	public wizardServer()  throws IOException{
		server = new Server();
		
		cList = new LinkedList<Connection>();
		cList2 = new LinkedList<Connection>();
		count = 0;
		registerPackets();
		//TODO
		wizardListenerS l = new wizardListenerS(this);
		server.addListener(l);
		server.bind(1199);
		server.start();
	}
	
	private void registerPackets(){
		Kryo kryo = server.getKryo();
		kryo.register(Packet0000LogInfo.class);
		kryo.register(Packet0001LogInAccepted.class);
		kryo.register(Packet0002Message.class);
		kryo.register(Packet0003SyncReq.class);
		kryo.register(Packet0004Ack.class);
		kryo.register(PacketInt.class);
	}
	
	public void broadcastOnce(){
		for (Connection c: cList){
			Packet0002Message p = new Packet0002Message();
			p.message = "Two Person Play! Size is " + cList.size();
			c.sendTCP(p);
		}
		cList.clear();
		count = 0;
	}
	
	public void broadcastAgain(){
		Packet0002Message p = new Packet0002Message();
		p.message = "Two Person Play! Size is " + cList.size();
		server.sendToAllTCP(p);
	}
	
	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}
	
	public static void main(String[] args) throws IOException{
		new wizardServer();
	}
	
	public void sendAll(Object arg){
		server.sendToAllTCP(arg);
	}
	
	public void sendAllExcept(int arg0, Object arg1){
		server.sendToAllExceptTCP(arg0, arg1);
	}
}
