package amidagame;

import amidagame.packets.*;

import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;

public class AmidaListenerS extends Listener {
	private AmidaServer server;
	
	public AmidaListenerS(AmidaServer server){
		this.server = server;
		server.connecting = true;
	}
	
	public void connected(Connection arg0){
		// DO SOMETHING
		System.out.println("AAAA-S");
	}
	
	public void disconnected(Connection arg0){
		// DO SOMETHING
		System.out.println("BBBB-S");
	}
	
	public void received(Connection arg0, Object arg1){
		// DO SOMETHING
		System.out.println("CCCC-S");
		/*
		if (arg1 instanceof Packet0000LogInfo){
			Packet0001LogInAccepted p = new Packet0001LogInAccepted();
			p.accepted = true;
			arg0.sendTCP(p);
		}
		if (arg1 instanceof Packet0002Message){
			String message = ((Packet0002Message) arg1).message;
			if (message.equals("wow wow")){
				System.out.println("VENUS");
			} else if (message.equals("Exit")){
				connecting = false;
			}
			System.out.println("The meEEEEEssage is: " + message);
		}
		if (arg1 instanceof Packet0003SyncReq){
			server.setCount(server.getCount() + 1);
			server.cList.add(arg0);
			if (server.getCount() >= 2){
				server.broadcastAgain();
			}
		}
		if (arg1 instanceof Packet0004Ack){
			System.out.println("Ack received!");
			
			SThread st = new SThread(arg0);
			st.start();
		}
		*/
		
		if (arg1 instanceof PackageAmidaLogIn){
			if (((PackageAmidaLogIn) arg1).permit){
				if (((PackageAmidaLogIn) arg1).gameid >= 0){
					server.createNewGame(((PackageAmidaLogIn) arg1).gameid);
				}
				
				PackageAmidaLogInAccepted p = new PackageAmidaLogInAccepted();
				p.pid = assignNewPid();
				p.answer = true;
				arg0.sendTCP(p);
			}
		}
		if (arg1 instanceof PackageAmidaAck){
			UpdateThread ut = new UpdateThread(arg0, ((PackageAmidaAck) arg1).pid, ((PackageAmidaAck) arg1).gameid);
			ut.start();
		}
		
		if (arg1 instanceof PackageDrawLineReq){
			PackageDrawLineReq r = (PackageDrawLineReq) arg1;
			//server.addNewLine(r.x, r.y, r.pid);
			server.broadcastNewLine(r);
		}
		
		if (arg1 instanceof PackageAmidaGameOver){
			//TODO Do something when the game is over;
			// Broadcasting when all game over package was sent
			// Just a simple package says DONE!
			server.resetGame();
		}
		
		if (arg1 instanceof PackageUnregisterPlayer){
			PackageUnregisterPlayer p = (PackageUnregisterPlayer) arg1;
			if (p.pid == 44){
				server.resetGame();
			}else{
				server.playersId[p.pid] = false;
			}
		}
		
		if (arg1 instanceof PackageCoinReq){
			server.drawCoins(arg0, (PackageCoinReq) arg1);
		}
	}
	
	private short assignNewPid() {
		return server.assignNewPid();
	}

	public class UpdateThread extends Thread{
		Connection con;
		short pid;
		int gameid;
		
		public UpdateThread(Connection con, short pid, int gameid){
			this.con = con;
			this.pid = pid;
			this.gameid = gameid;
		}	
		
		@Override
		public void run() {
			// TODO Auto-generated method stub
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			server.boardcastNewLines(con, pid, gameid);
			
			System.out.println("Ack sent");
		}
		
	}
}
