package chatNetworking;

import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;
import com.example.lctnetworktesting.networking.packets.*;

public class ChatListenerS extends Listener {
	private ChatServer server;
	boolean connecting;
	private int pid = 0;

	public ChatListenerS(ChatServer server) {
		this.server = server;
		connecting = true;
	}

	public void connected(Connection arg0) {
		// DO SOMETHING
		System.out.println("AAAA-S");
	}

	public void disconnected(Connection arg0) {
		// DO SOMETHING
		if (pid > 0){ 
			pid--;
			}
			System.out.println("removed");
			server.cList.remove(arg0);
		System.out.println("BBBB-S");
	}

	public void received(Connection arg0, Object arg1) {
		// DO SOMETHING
		System.out.println("CCCC-S");
		if (arg1 instanceof Packet0000LogInfo) {
			Packet0001LogInAccepted p = new Packet0001LogInAccepted();
			p.accepted = true;
			arg0.sendTCP(p);
			Packet0005Number pidP = new Packet0005Number();
			pid++;
			pidP.id = pid;
			arg0.sendTCP(pidP);
			server.cList.add(arg0);
			
		}
		if (arg1 instanceof Packet0002Message) {
			String message = ((Packet0002Message) arg1).message;
			if (message.equals("wow wow")) {
				System.out.println("VENUS");
			} else if (message.equals("Exit")) {
				connecting = false;
			}
			System.out.println("The meEEEEEssage is: " + message);
		}
		if (arg1 instanceof Packet0007String) {
			char[] message = ((Packet0007String) arg1).message;
			for (Connection c : server.cList) {
				System.out.println("sent to client");
				Packet0007String p = new Packet0007String();
				p.message = message;
				c.sendTCP(p);
			}
		}
		if (arg1 instanceof Packet0003SyncReq) {
			server.setCount(server.getCount() + 1);
			server.cList.add(arg0);
			if (server.getCount() >= 2) {
				server.broadcastAgain();
			}
		}
		if (arg1 instanceof Packet0004Ack) {
			System.out.println("Ack received!");

			SThread st = new SThread(arg0);
			st.start();
		}
	}

	public class SThread extends Thread {
		Connection con;

		public SThread(Connection con) {
			this.con = con;
		}

		@Override
		public void run() {
			// TODO Auto-generated method stub
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			Packet0004Ack p = new Packet0004Ack();
			p.connecting = connecting;
			con.sendTCP(p);

			System.out.println("Ack sent");
		}

	}
}
