package creaturegame;

import android.util.Log;

import com.esotericsoftware.kryonet.Client;
import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;
import com.example.lctnetworktesting.networking.packets.*;

public class CCListenerC extends Listener {
	private CCClient client;

	public void connected(Connection arg0) {
		// DO SOMETHING
		Log.i("Clinet", "Connected with server!" + arg0.toString());
		client.client.sendTCP(new Packet0000LogInfo());
	}

	public void disconnected(Connection arg0) {
		// DO SOMETHING
		Log.i("Client", "Disconnect from server");
	}

	public void received(Connection arg0, Object arg1) {
		// DO SOMETHING
		Log.i("Client", "Received something frmo the server");
		if (arg1 instanceof Packet0001LogInAccepted) {
			boolean answer = ((Packet0001LogInAccepted) arg1).accepted;

			// TODO Something to be finished

			if (answer == true) {
				client.client.sendTCP(new Packet0004Ack());
			} else {
				client.client.close();
			}
		}
		if (arg1 instanceof Packet0002Message) {
			String message = ((Packet0002Message) arg1).message;
			Log.i("Client", "The message is: " + message);
		}
		if (arg1 instanceof Packet0006AssignParts) {
			int pid = ((Packet0006AssignParts) arg1).number;
			client.getGame().setAssigenment(pid);
			Log.i("Client", "The pid is: " + pid);
		}
		if (arg1 instanceof Packet0005Number) {
			int id = ((Packet0005Number) arg1).id;
			int value = ((Packet0005Number) arg1).value;
			Log.i("Client", "The number is: " + id + " " + value);
			client.getGame().setImages(id, value);
		}
		if (arg1 instanceof Packet0009Ready) {
			client.getGame().setTimer();
			Log.i("Client", "Ready");
		}
		if (arg1 instanceof Packet0004Ack) {
			Log.i("Client", "Ack Received!");

			boolean connecting = ((Packet0004Ack) arg1).connecting;

			if (connecting) {
				SThread st = new SThread();
				st.start();
			}
		}
	}

	public void init(CCClient client) {
		this.client = client;
	}

	/*
	 * private void enterMessage(){ Log.i("Client", "Say something!");
	 * 
	 * while(true) { if (LCTClient.scanner.hasNext()){ Packet0002Message mp =
	 * new Packet0002Message(); mp.message = LCTClient.scanner.nextLine(); if
	 * (mp.message.equals("Sync")){ client.sendTCP(new Packet0003SyncReq());
	 * break; } client.sendTCP(mp); Log.i("Client", "Say something more!"); } }
	 * }
	 */

	public class SThread extends Thread {
		@Override
		public void run() {
			// TODO Auto-generated method stub
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			client.client.sendTCP(new Packet0004Ack());
			Log.i("Client", "Ack sent!");
		}

	}
}
