package lanceGameRoomNetworking;

import android.app.Activity;

public class GameInfoManager {
	private static GameInfoManager instance = new GameInfoManager();
	
	public static GameInfoManager getInstance(){
		return instance;
	}
	
	public String retrieveGameName(int gameId){
		switch (gameId){
			case 1:
				return "Treasure Trap";
			case 2:
				return "Bomb Pass Panic";
			case 3:
				return "Creature Creator";
			case 4:
				return "Elemancer";
			default:
				return "Unknown";	
		}
	}
	
	public int retrieveMaxPlayers(int gameId){
		switch (gameId){
			case 1:
				return 4;
			case 2:
				return 6;
			case 3:
				return 4;
			case 4:
				return 4;
			default:
				return 0;	
		}
	}
}
