package networking.component;
import networking.packets.*;

import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;

public class LCTListenerS extends Listener {
	private LCTServer server;
	
	public LCTListenerS(LCTServer server){
		this.server = server;
	}
	
	public void connected(Connection arg0){
		// DO SOMETHING
		System.out.println("AAAA-S");
	}
	
	public void disconnected(Connection arg0){
		// DO SOMETHING
		System.out.println("BBBB-S");
	}
	
	public void received(Connection arg0, Object arg1){
		// DO SOMETHING
		System.out.println("CCCC-S");
		if (arg1 instanceof Packet0000LogInfo){
			Packet0001LogInAccepted p = new Packet0001LogInAccepted();
			p.accepted = true;
			arg0.sendTCP(p);
		}
		if (arg1 instanceof Packet0002Message){
			String message = ((Packet0002Message) arg1).message;
			if (message.equals("wow wow")){
				System.out.println("VENUS");
			} else if (message.equals("Exit")){
				System.exit(0);
			}
			System.out.println("The meEEEEEssage is: " + message);
		}
		if (arg1 instanceof Packet0003SyncReq){
			server.setCount(server.getCount() + 1);
			server.cList.add(arg0);
			if (server.getCount() >= 2){
				server.broadcastAgain();
			}
		}
	}
}
