package potatogame;

import loadingscenes.LPotatoSetup;
import android.util.Log;

import com.esotericsoftware.kryonet.Client;
import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;

public class potatoListener extends Listener {
	private Client pclient;
	private LPotatoSetup lps = null;
	private potatoSetup ps = null;
	
	private Integer current = 1;
	
	public void setLPS(LPotatoSetup LPS){
		lps = LPS;
	}
	
	public void setPS(potatoSetup PS){
		ps = PS;
	}
	
	public void setCur(int i){
		current = i;
	}
	
	public void connected(Connection arg0){
		// DO SOMETHING
		Log.i("Clinet","Connected with server!" + arg0.toString());
		pclient.sendTCP(new Packet0000LogInfo());
	}
	
	public void disconnected(Connection arg0){
		// DO SOMETHING
		Log.i("Client","Disconnect from server");
	}
	
	public void received(Connection arg0, Object arg1){
		// DO SOMETHING
		//Log.i("Client", "Received something from the server");
		if (arg1 instanceof Packet0001LogInAccepted){
			boolean answer = ((Packet0001LogInAccepted) arg1).accepted;
			
			// TODO Something to be finished
			
			if (answer == true){
				pclient.sendTCP(new Packet0004Ack());
			} else {
				pclient.close();
			}
		}
		if (arg1 instanceof Packet0002Message){
			String message = ((Packet0002Message) arg1).message;
			Log.i("Client", "The message is: " + message);
		}
		if (arg1 instanceof PacketInt){
			int message = ((PacketInt) arg1).i;
			String temp = "" + message;
			if(temp.length() > 1){
				if(temp.charAt(0) == '1'){
					if(lps != null){
						lps.start();
					}
				}
				else if(temp.charAt(0) == '2'){
					if(lps != null){
						Integer temp2 = Integer.parseInt(temp.substring(1,2));
						lps.setSelfNum(temp2.intValue());
					}
				}
				else if(temp.charAt(0) == '3'){
					if(ps!=null){
						if(temp.length() > 2){
							Integer temp2 = Integer.parseInt(temp.substring(1,2));
							if(temp2.intValue() == current){
								Integer temp3 = Integer.parseInt(temp.substring(2,3));
								current = temp3.intValue();
								ps.recievePassPacket(temp3.intValue());
							}
							else if(temp2.intValue() == 8){
								//this indicates loss at the end of a timer
								Integer temp3 = Integer.parseInt(temp.substring(2,3));
								current = temp3.intValue();
								//handle loss
							}
							else if(temp2.intValue() == 9){
								//this indicates the player did not swipe in time.
								Integer temp3 = Integer.parseInt(temp.substring(2,3));
								current = temp3.intValue();
								ps.recieveLoss(temp3.intValue());
							}
						}
					}
				}
			}
			Log.i("Client", "The message is: " + message);
		}
		if (arg1 instanceof Packet0004Ack){
			//Log.i("Client", "Ack Received!");
			
			boolean connecting = ((Packet0004Ack) arg1).connecting;
			
			if (connecting){
				SThread st = new SThread();
				st.start();
			}
		}
		if (arg1 instanceof PacketHash){
			if(lps != null){
				lps.setHash(((PacketHash) arg1).h);
			}
		}
	}

	public void init(Client client) {
		this.pclient =  client;
	}
	
	
	public class SThread extends Thread{
		@Override
		public void run() {
			// TODO Auto-generated method stub
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			pclient.sendTCP(new Packet0004Ack());
			//Log.i("Client", "Ack sent!");
		}
		
	}
}
