package viewUsers;

import java.util.LinkedList;

import database.Pair;

public class OtherUser {
	//info for another user
	//NOT THE CURRENT PLAYER
	//THAT IS STORED IN SHAREDPREFs
	//Traingame info is stored in TrainStats
	
	private Integer UID;
	private String username;
	private String plays;
	private String cargo_trades;
	private String curr_train_score;
	private String user_score;
	private LinkedList<Pair<String, String>> high_scores;
	
	/**
	 * For use in the parlor room. Get more info from db as needed.
	 * @param UID
	 * @param username
	 * @param plays
	 */
	public OtherUser(Integer UID) {
		this.UID = UID;
		this.username = null;
		this.plays = null;		
		this.cargo_trades = null;
		this.curr_train_score = null;
		this.user_score = null;
		this.high_scores = null;
	}
	
	/**
	 * For use in the parlor room. Get more info from db as needed.
	 * @param UID
	 * @param username
	 * @param plays
	 */
	public OtherUser(Integer UID, String username, String plays) {
		this.UID = UID;
		this.username = username;
		this.plays = plays;		
		this.cargo_trades = null;
		this.curr_train_score = null;
		this.user_score = null;
		this.high_scores = null;
	}
	
	public OtherUser(Integer UID, String username, String plays, String cargo_trades,
			String curr_train_score, String user_score,
			LinkedList<Pair<String, String>> high_scores) {
		this.UID = UID;
		this.username = username;
		this.plays = plays;
		this.cargo_trades = cargo_trades;
		this.curr_train_score = curr_train_score;
		this.user_score = user_score;
		this.high_scores = high_scores;
	}

	/**
	 * @return the uID
	 */
	public Integer getUID() {
		return UID;
	}

	/**
	 * @param uID the uID to set
	 */
	public void setUID(Integer uID) {
		UID = uID;
	}

	/**
	 * @return the username
	 */
	public String getUsername() {
		return username;
	}

	/**
	 * @param username the username to set
	 */
	public void setUsername(String username) {
		this.username = username;
	}

	/**
	 * @return the plays
	 */
	public String getPlays() {
		return plays;
	}

	/**
	 * @param plays the plays to set
	 */
	public void setPlays(String plays) {
		this.plays = plays;
	}

	/**
	 * @return the cargo_trades
	 */
	public String getCargo_trades() {
		return cargo_trades;
	}

	/**
	 * @param cargo_trades the cargo_trades to set
	 */
	public void setCargo_trades(String cargo_trades) {
		this.cargo_trades = cargo_trades;
	}

	/**
	 * @return the curr_train_score
	 */
	public String getCurr_train_score() {
		return curr_train_score;
	}

	/**
	 * @param curr_train_score the curr_train_score to set
	 */
	public void setCurr_train_score(String curr_train_score) {
		this.curr_train_score = curr_train_score;
	}

	/**
	 * @return the user_score
	 */
	public String getUser_score() {
		return user_score;
	}

	/**
	 * @param user_score the user_score to set
	 */
	public void setUser_score(String user_score) {
		this.user_score = user_score;
	}

	/**
	 * @return the high_scores
	 */
	public LinkedList<Pair<String, String>> getHigh_scores() {
		return high_scores;
	}

	/**
	 * @param high_scores the high_scores to set
	 */
	public void setHigh_scores(LinkedList<Pair<String, String>> high_scores) {
		this.high_scores = high_scores;
	}
	
	
	
}
