package wizardgame;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import android.annotation.SuppressLint;

import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;

@SuppressLint("UseSparseArrays")
public class wizardListenerS extends Listener{
	private wizardServer server;
	boolean connecting = true;
	private int connected = 0;
	private HashMap<Integer,Integer> gameInfo = new HashMap<Integer,Integer>();
	private HashMap<Integer, List<Connection>> Cons = new HashMap<Integer, List<Connection>>();
	private HashMap<Integer, List<Connection>> Cons2 = new HashMap<Integer, List<Connection>>();

	public wizardListenerS(wizardServer Server){
		this.server = Server;
		connecting = true;
	}
	
	public void connected(Connection arg0){
		// DO SOMETHING
		System.out.println("AAAA-S");
	}
	
	public void disconnected(Connection arg0){
		// DO SOMETHING
		System.out.println("BBBB-S");
	}
	
	public void received(Connection arg0, Object arg1){
		// DO SOMETHING
		//System.out.println("CCCC-S");
		if (arg1 instanceof PacketInt){
			int message = ((PacketInt) arg1).i;
			System.out.println("The meEEEEEssage is: " + message);
			String info = "" + message;
			if(info.startsWith("1")){
				String gameid = info.substring(1);
				Integer gameID = Integer.decode(gameid);
				if(!(gameInfo.containsKey(gameID))){
					Cons2.remove(gameID);
					List<Connection> c = new ArrayList<Connection>();
					c.add(arg0);
					Cons.put(gameID, c);
					gameInfo.put(gameID, 1);
					((PacketInt) arg1).i = 11;
					arg0.sendTCP(arg1);
					//also send an additional to self so they know which user
					//they are.
					((PacketInt) arg1).i = 21;
					arg0.sendTCP(arg1);
				}
				else{
					List<Connection> c = Cons.get(gameID);
					Cons.remove(gameID);
					gameInfo.remove(gameID);
					((PacketInt) arg1).i = 12;
					c.get(0).sendTCP(arg1);
					arg0.sendTCP(arg1);
					//also send an additional to self so they know which user
					//they are.
					((PacketInt) arg1).i = 22;
					arg0.sendTCP(arg1);
				}
			}
			else if(info.startsWith("2")){
				//Connecting from game
				String gameid = info.substring(1);
				Integer gameID = Integer.decode(gameid);
				if(!Cons2.containsKey(gameID)){
					List<Connection> c = new ArrayList<Connection>();
					c.add(arg0);
					Cons2.put(gameID, c);
				}
				else{
					Cons2.get(gameID).add(arg0);
				}
			}
			else if(info.startsWith("3") || info.startsWith("4")){
				//coming from in game to send to the opponent
				Integer gameID = ((PacketInt) arg1).gid;
				Connection co = Cons2.get(gameID).get(0);
				if(co != arg0){
					co.sendTCP(arg1);
				}
				else if(Cons2.get(gameID).size() > 1){
					Cons2.get(gameID).get(1).sendTCP(arg1);
				}
			}
			else if (info.startsWith("5")){
				Integer gameID = ((PacketInt) arg1).gid;
				Cons2.remove(gameID);
			}
			else{
				arg0.sendTCP(arg1);
			}
		}
		if (arg1 instanceof Packet0002Message){
			String message = ((Packet0002Message) arg1).message;
			if (message.equals("wow wow")){
				System.out.println("VENUS");
			} else if (message.equals("Exit")){
				connecting = false;
			}
			System.out.println("The meEEEEEssage is: " + message);
		}
		if (arg1 instanceof Packet0004Ack){
			//System.out.println("Ack received!");
			
			SThread st = new SThread(arg0);
			st.start();
		}
		if (arg1 instanceof Packet0003SyncReq){
			server.setCount(server.getCount() + 1);
			server.cList.add(arg0);
			if (server.getCount() >= 2){
				server.broadcastAgain();
			}
		}
		if (arg1 instanceof Packet0000LogInfo){
			Packet0001LogInAccepted p = new Packet0001LogInAccepted();
			p.accepted = true;
			arg0.sendTCP(p);
		}
	}
	
	public class SThread extends Thread{
		Connection con;
		
		public SThread(Connection con){
			this.con = con;
		}	
		
		@Override
		public void run() {
			// TODO Auto-generated method stub
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			Packet0004Ack p = new Packet0004Ack();
			p.connecting = connecting;
			con.sendTCP(p);
			
			//System.out.println("Ack sent");
		}
		
	}
}
